/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

typedef enum ptype_e
{
	pt_static,
	pt_grav,
	pt_slowgrav,
	pt_fire,
	pt_explode,
	pt_explode2,
	pt_blob,
	pt_blob2,
	MAX_PARTICLE_TYPES
} ptype_t;

typedef struct ptypedef_s
{
	vec3_t	dvel;
	vec3_t	grav;
	int		*ramp;
	float	ramptime;
	vec3_t	accel;
} ptypedef_t;


extern ptypedef_t p_typedefs[MAX_PARTICLE_TYPES];

// !!! if this is changed, it must be changed in d_ifacea.h too !!!
typedef struct particle_s
{
	// driver-usable fields
	vec3_t		move;
	int			color;

	// drivers never touch the following fields
	struct particle_s	*next;

	vec3_t		org;
	vec3_t		vel;
	float		ramp;
	float		die;
	ptype_t		type;
} particle_t;

typedef struct emitter_s
{
	float time;
	float origin[3];
	float mins[3], maxs[3];
	particle_t *particles;

	struct emitter_s *next;
} emitter_t;

extern emitter_t *free_emitters;
extern emitter_t *active_emitters;

extern int ramp1[];
extern int ramp2[];
extern int ramp3[];

