!!ARBfp1.0

# fragment.texcoord[0] is texture coord
# fragment.texcoord[1] is normal
# fragment.texcoord[2] is light vector

# program.env[0] is light radius
# program.env[1] is light style

# program.env[2] is spotvec
# program.env[3] is falloff

TEMP diff;
TEMP normal;
TEMP incoming;
TEMP dist;
TEMP light;
TEMP angle;
# TEMP spotfade;

# brings lights back to a 0..1 range (light.exe used 0..255)
PARAM rescale = {0.00390625, 0.00390625, 0.00390625, 0};

# perform the texturing; doing this early so it can interleave with ALU ops
TEX diff, fragment.texcoord[0], texture[0], 2D;

# normalize incoming normal
DP3 normal.w, fragment.texcoord[1], fragment.texcoord[1];
RSQ normal.w, normal.w;
MUL normal.xyz, normal.w, fragment.texcoord[1];

# normalize incoming light vector (this could be done in the vp)
DP3 incoming.w, fragment.texcoord[2], fragment.texcoord[2];
RSQ incoming.w, incoming.w;
RCP dist, incoming.w;	# get the vector length while we're at it
MUL incoming.xyz, incoming.w, fragment.texcoord[2];

# do the spotlight calculation; this is the same calculation used by light.exe
DP3 angle, program.env[2], incoming;
SUB angle, program.env[3], angle;
KIL angle;

# read a smooth fade on the spotlight
# TEX spotfade, angle, texture[1], 2D;

# adjust for normal; this is the same calculation used by light.exe
DP3 angle, incoming, normal;
MAD angle, angle, 0.5, 0.5;

# get the light attenuation
SUB light, program.env[0], dist;
MUL light, light, rescale;
MUL light, light, program.env[1];
MUL light, light, angle;

# modulate by spotfade to remove hard edges
# MUL light, light, spotfade;

# move to output
MUL result.color, diff, light;

# done
END
